clang 10.0.0git

Public Member Functions | List of all members
clang::Sema::DelayedDiagnostics Class Reference

A class which encapsulates the logic for delaying diagnostics during parsing and other processing. More...

`#include "clang/Sema/Sema.h"`

## Public Member Functions
| DelayedDiagnostics ()
void | add (const sema::DelayedDiagnostic &diag)
| Adds a delayed diagnostic. More...
bool | shouldDelayDiagnostics ()
| Determines whether diagnostics should be delayed. More...
sema::DelayedDiagnosticPool * | getCurrentPool () const
| Returns the current delayed-diagnostics pool. More...
DelayedDiagnosticsState | push (sema::DelayedDiagnosticPool &pool)
| Enter a new scope. More...
void | popWithoutEmitting (DelayedDiagnosticsState state)
| Leave a delayed-diagnostic state that was previously pushed. More...
DelayedDiagnosticsState | pushUndelayed ()
| Enter a new scope where access and deprecation diagnostics are not delayed. More...
void | popUndelayed (DelayedDiagnosticsState state)
| Undo a previous pushUndelayed(). More...

## Detailed Description

A class which encapsulates the logic for delaying diagnostics during parsing and other processing.

Definition at line 745 of file Sema.h.

## Constructor & Destructor Documentation

## ◆ DelayedDiagnostics()

clang::Sema::DelayedDiagnostics::DelayedDiagnostics | ( |  | ) |
| inline

Definition at line 751 of file Sema.h.

## Member Function Documentation

## ◆ add()

void clang::Sema::DelayedDiagnostics::add | ( | const sema::DelayedDiagnostic & | diag | ) |
| inline

Adds a delayed diagnostic.

Add a diagnostic to the current delay pool.

Definition at line 330 of file DelayedDiagnostic.h.

## ◆ getCurrentPool()

sema::DelayedDiagnosticPool* clang::Sema::DelayedDiagnostics::getCurrentPool | ( |  | ) | const
| inline

Returns the current delayed-diagnostics pool.

Definition at line 760 of file Sema.h.

Referenced by clang::Sema::ActOnEndOfTranslationUnit().

## ◆ popUndelayed()

void clang::Sema::DelayedDiagnostics::popUndelayed | ( | DelayedDiagnosticsState | state | ) |
| inline

Undo a previous pushUndelayed().

Definition at line 790 of file Sema.h.

Referenced by clang::Sema::ContextRAII::pop(), and clang::Sema::PopParsingClass().

## ◆ popWithoutEmitting()

void clang::Sema::DelayedDiagnostics::popWithoutEmitting | ( | DelayedDiagnosticsState | state | ) |
| inline

Leave a delayed-diagnostic state that was previously pushed.

Do not emit any of the diagnostics. This is performed as part of the bookkeeping of popping a pool "properly".

Definition at line 776 of file Sema.h.

## ◆ push()

DelayedDiagnosticsState clang::Sema::DelayedDiagnostics::push | ( | sema::DelayedDiagnosticPool & | pool | ) |
| inline

Enter a new scope.

Access and deprecation diagnostics will be collected in this pool.

Definition at line 766 of file Sema.h.

References clang::CodeGen::state.

Referenced by clang::Sema::PushParsingDeclaration().

## ◆ pushUndelayed()

DelayedDiagnosticsState clang::Sema::DelayedDiagnostics::pushUndelayed | ( |  | ) |
| inline

Enter a new scope where access and deprecation diagnostics are not delayed.

Definition at line 782 of file Sema.h.

References clang::CodeGen::state.

Referenced by clang::Sema::PushParsingClass().

## ◆ shouldDelayDiagnostics()

bool clang::Sema::DelayedDiagnostics::shouldDelayDiagnostics | ( |  | ) |
| inline

Determines whether diagnostics should be delayed.

Definition at line 757 of file Sema.h.

The documentation for this class was generated from the following files:

- include/clang/Sema/Sema.h
- include/clang/Sema/DelayedDiagnostic.h